;;;; stack-test.scm

(use testbase testbase-output-compact)
(use stack)

(define-test stack-test "Stack"

	(test/case "Make/Size" 
	
		(expect-not-false (make-stack))
		(expect-true (stack? (make-stack)))
		(expect-true (stack-empty? (make-stack)))
		(expect-eqv 0 (stack-length (make-stack)))
		(expect-eqv -1 (stack-depth (make-stack)))
	)

	(test/case "Push/Pop/Peek/Poke" (
			[stk #f]
		)
	
		(expect-set! stk (make-stack))
		(expect-success (stack-push! stk 1))
		(expect-success (stack-push! stk 2 3))
		(expect-eqv 3 (stack-length stk))
		(expect-eqv 2 (stack-depth stk))
		(expect-eqv 3 (stack-pop! stk))
		(expect-eqv 2 (stack-pop! stk))
		(expect-eqv 1 (stack-pop! stk))
		(expect-true (stack-empty? stk))
		(expect-failure (stack-pop! stk))
		(expect-success (stack-push! stk 1 2 3))
		(expect-eqv 2 (stack-peek stk 1))
		(expect-success (stack-poke! stk 4 1))
		(expect-eqv 3 (stack-pop! stk))
		(expect-eqv 4 (stack-pop! stk))
		(expect-eqv 0 (stack-depth stk))
	)

	(test/case "Cut" (
			[stk (make-stack)]
		)
	
		(expect-success (stack-push! stk 1 2 3))
		(expect-equal '(2) (stack-cut! stk 1))
		(expect-eqv 2 (stack-length stk))
		(expect-success (stack-push! stk 4 5))
		(expect-equal '(4 3 1) (stack-cut! stk 1 3))
		(expect-eqv 1 (stack-length stk))
	)

	(test/case "Aux" (
			[stk (make-stack)]
			[stk1 #f]
		)
	
		(expect-success (stack-push! stk 1 2 3))
		(expect-equal '(3 2 1) (stack->list stk))
		(expect-set! stk1 (list->stack '(1 2 3)))
		(expect-true (stack? stk1))
		(expect-eqv 3 (stack-length stk1))
		(expect-eqv 1 (stack-pop! stk1))
	)
)

(test::styler-set! stack-test test::output-style-compact)
(run-test "Stack Test")
